=== modified file 'src/com/goldencode/p2j/uast/SymbolResolver.java'
--- old/src/com/goldencode/p2j/uast/SymbolResolver.java	2022-05-16 16:24:45 +0000
+++ new/src/com/goldencode/p2j/uast/SymbolResolver.java	2022-05-23 20:07:33 +0000
@@ -3909,29 +3945,21 @@
     */
    public void addClass(Aast symbol, Aast inherits, Aast imple, String file)
    {
-      Set<String>     ifaces = null;
-      String          name   = symbol.getText();
+      String name = symbol.getText();
       
       WorkArea wa = locate();
       if (wa.preScanPass == 0)
       {
-         loadClass(name);
+         loadClass(name, true);
       }
       
       SearchResult found = resolveClassName(name);
       ClassDefinition[] parents = calculateParents(name, inherits, found.dotnet);
+      ClassDefinition[] ifaces  = null; 
       
       if (imple != null)
       {
-         ifaces = new HashSet<String>();
-         
-         Aast child = imple.getChildAt(0);
-         
-         while (child != null)
-         {
-            ifaces.add((String) child.getAnnotation("qualified"));
-            child = (Aast) child.getNextSibling();
-         }
+         ifaces = calculateParents(name, imple, found.dotnet);         
       }
 
       addClass(name, parents, ifaces, found.builtin, found.dotnet, file);
@@ -3959,7 +3987,7 @@
     */
    public void addClass(String            name,
                         ClassDefinition[] parents,
-                        Set<String>       ifaces,
+                        ClassDefinition[] ifaces,
                         boolean           builtin,
                         boolean           dotnet,
                         String            file)
@@ -4046,7 +4074,7 @@
       WorkArea wa = locate();
       if (wa.preScanPass == 0)
       {
-         loadClass(name);
+         loadClass(name, true);
       }
 
       ClassDefinition iface = lookupClass(name);
@@ -4096,7 +4124,7 @@
       WorkArea wa = locate();
       if (wa.preScanPass == 0)
       {
-         loadClass(name);
+         loadClass(name, true);
       }
 
       ClassDefinition edef = lookupClass(name);
@@ -4132,7 +4160,7 @@
          {
             Variable value__ = new Variable("value__", VAR_INT, null);
             addVariable(true, value__);
-            edef.addVariable("value__", value__, null, KW_PUBLIC, false, null, false);
+            edef.addVariable(DEFINE_ENUM, "value__", value__, null, KW_PUBLIC, false, null, false);
             value__.setAnnotationHelper((Variable var, Aast ast, boolean ori, boolean meth, SymbolResolver sym) ->
             {
                ast.putAnnotation("dotnet-enum-implicit-value", true);
@@ -4176,7 +4204,7 @@
          var.annotateOptions(symbol, true, false, this);
       
          // we register it as static because it is implicitly static in its lookup
-         cls.addVariable(name, var, symbol, KW_PUBLIC, true, qname, false);
+         cls.addVariable(DEFINE_ENUM, name, var, symbol, KW_PUBLIC, true, qname, false);
       }
    }
    
@@ -4315,6 +4343,42 @@
     */
    public String loadClass(String name)
    {
+      return loadClass(name, false);
+   }
+   
+   /**
+    * Load (using recursion if needed) the hierarchy of class definitions (or
+    * a single interface definition) referenced by the given name. This should
+    * be called when a reference to a class or interface name occurs (except
+    * in the case of the <code>CLASS</code> or <code>INTERFACE</code> language
+    * statements). The name can be unqualified (requiring a call to
+    * {@link #resolveClassName} to determine the fully qualified name) or it
+    * can be either partially or fully qualified (partially qualified names were
+    * added in v11). Once resolved, if the class or interface definition
+    * is already loaded, then this will return immediately.  Otherwise the
+    * class or interface file will be found via the <code>PROPATH</code> and
+    * that file's AST will be loaded.  If the AST does not exist, then the
+    * file will first be parsed. During parsing, the <code>CLASS</code> or 
+    * <code>INTERFACE</code> language statements will call {@link #addClass}
+    * or {@link #addInterface} respectively. This will instantiate the proper
+    * {@link ClassDefinition} objects and the contained definitions for
+    * methods, member variables and properties will be added by the rules
+    * that match those language features. Once parsing is complete, the
+    * definition will be fully formed and loaded. Any references to other
+    * classes or interfaces in that file will cause recursive parsing/loading
+    * using this method, until the entire object hierarchy is loaded. At that
+    * point, this chain of methods will return.
+    *
+    * @param    name
+    *           Unqualified or partially/fully qualified class or interface name to
+    *           load.
+    * @param    topLevel
+    *           {@code true} if the named class is already being parsed in the caller.
+    *
+    * @return   The fully qualified class or interface name that was loaded.
+    */
+   public String loadClass(String name, boolean topLevel)
+   {   
       SearchResult found = resolveClassName(name);
 
       ClassDefinition cls = lookupClass(found.clsname);
@@ -4383,7 +4447,7 @@
             generator.setCache(true);
             generator.setDumpLexer(true);
             generator.setDumpParser(true);
-            generator.setAstPersist(false);
+            generator.setAstPersist(true);
          }
 
          String relative = Configuration.normalizeFilename(found.filename);
@@ -4410,6 +4474,12 @@
 
             // the PROPATH is inherited from the caller
             generator.preScanClass(relative, found.builtin, found.dotnet, this.propath);
+            
+            // save all referenced classes/interfaces except for the genesis object
+            if (wa.preScanPass > 1)
+            {
+               wa.processed.add(found.clsname);
+            }
          }
          catch (AstException   |
                 ANTLRException |
@@ -4451,23 +4521,30 @@
             String err  = String.format(spec, found.clsname, relative);
             throw new RuntimeException(err);
          }
-      }         
-
-      // the class has been loaded (now or previously) - ensure all super-classes are loaded, too
-      if (!isPreScan())
-      {
-         if (generator == null)
+         
+         if (!isPreScan())
          {
-            generator = new AstGenerator();
-            generator.setSilent(silent);
-            generator.setPreprocess(true);
-            generator.setCache(true);
-            generator.setDumpLexer(true);
-            generator.setDumpParser(true);
-            generator.setAstPersist(false);
+            // we cannot just process the genesis object that started the graph; we must process all
+            // referenced classes/interfaces including those not in our parent hierarchy AND we need
+            // to process them in the same order they were processed previously
+            if (!wa.processed.isEmpty())
+            {
+               for (String fname : wa.processed)
+               {
+                  // ensure all super-classes are loaded for this object
+                  parseHierarchy(fname, wa);
+               }
+               
+               wa.processed.clear();
+            }
+            
+            // do NOT handle the 2nd level parsing of the genesis object here if that parsing is already
+            // happening in the caller
+            if (!topLevel)
+            {
+               parseHierarchy(cls.getName(), wa);
+            }
          }
-      
-         parseHierarchy(cls.getName());
       }      
 
       return found.clsname;
@@ -4573,7 +4650,8 @@
       // annotateClassRef, but left here in case there are other situations added.
       if (qname == null)
       {
-         System.out.println("FAILURE: Returning from annotateClassRef due null qname " + node.dumpTree(true));
+         System.out.println("FAILURE: Returning from annotateClassRef because of null qname " +
+                            node.dumpTree(true));
          return;
       }
       ClassDefinition cls = lookupClass(qname);
@@ -5038,8 +5116,6 @@
     *
     * @param    stype
     *           Defining language statement type.
-    * @param    extent
-    *           The extent.  Use 0 for no-extent (scalar member).
     * @param    name
     *           Member name.
     * @param    node
@@ -5050,17 +5126,27 @@
     * @param    stic
     *           Node of type <code>KW_STATIC</code> if the variable/property is
     *           static.
+    * @param    ov
+    *           Override node if specified.
+    * @param    ab
+    *           Abstract node if specified.
     * @param    qname
     *           Fully qualified class name for members that are references to a given class
     *           or <code>null</code> if this member is not an object instance.
+    * @param    extent
+    *           The extent value or 0 if there is no extent.  The AST cannot be inspected at this point
+    *           because all the child notes are not linked into the root node yet.  For this reason, the
+    *           explicit value must be passed.
     */
-   public void addDataMember(int    stype, 
-                             int    extent, 
-                             String name, 
-                             Aast   node, 
-                             Aast   access, 
-                             Aast   stic, 
-                             String qname)
+   public void addDataMember(int    stype,
+                             String name,
+                             Aast   node,
+                             Aast   access,
+                             Aast   stic,
+                             Aast   ov,
+                             Aast   ab,
+                             String qname,
+                             int    extent)
    {
       // this is called both in pre-scan and normal parse phases:
       // 1. in pre-scan, it will pickup and collect the DEF VAR scoped with methods/c'tor/etc
@@ -5078,7 +5164,7 @@
          
          boolean isStatic = (stic != null);
          boolean isProp = (stype == DEFINE_PROPERTY);
-                  
+         
          // if the previous definition is a property, and we are in pre-scan mode, then ignore it; this is
          // just a dirty fix for pre-scan mode, it's not complete
          if (var.isProp() && !isProp && isPreScan())
@@ -5089,13 +5175,15 @@
          var.setProperty(isProp);
          var.setStatic(isStatic);
          var.setExtent(extent);
-
-         trackMethodSignatures(stype, var, name);
+         var.setOverride(ov != null);
+         var.setAbstract(ab != null);
+            
+         trackPropertyOrEventMethodSignatures(stype, cls, node, var, name);
          
          // a variable is provisional during prescan, if and only if we have no explicit access modifier set
          boolean provisional = isPreScan() && stype == DEFINE_VARIABLE && access == null;
          
-         cls.addVariable(name, var, node, amode, isStatic, qname, provisional);
+         cls.addVariable(stype, name, var, node, amode, isStatic, qname, provisional);
       }
    }
    
@@ -6991,7 +7079,7 @@
     * given the field's name and an optional table name-node.
     * 
     * @param   table
-    *          Name node asssociated with the field reference. If not {@code null}, only the
+    *          Name node associated with the field reference. If not {@code null}, only the
     *          private namespace of the given {@code table} is searched (for an exact match)
     *          of {@code fieldName}. If {@code null}, a lenient search (i.e., abbreviations
     *          permitted) is performed across all scopes in the schema dictionary.
@@ -7050,6 +7138,45 @@
    }
    
    /**
+    * Look up and return the table info instance which describes a database table in a schema.
+    *
+    * @param   name
+    *          Text string to match, exactly as found in the original source code
+    *          (abbreviated, qualified or unqualified). 
+    * @param   forceTemp
+    *          If <code>true</code>, force a temp-table lookup.
+    * @param   forcePersistent
+    *          If <code>true</code>, force a persistent table lookup.
+    *
+    * @return  The table info instance or <code>null</code> if no match was found.
+    */
+   public TableInfo lookupTableInfo(String name, boolean forceTemp, boolean forcePersistent)
+   {
+      TableInfo result = null;
+      
+      try
+      {
+         if (schemaDict != null)
+         {
+            SchemaHelper<TableInfo> info = (SchemaDictionary dict) -> 
+            {
+               return dict.findTableInfo(name, forceTemp, forcePersistent);
+            };
+               
+            Predicate<TableInfo> notNull = (TableInfo val) -> { return (val == null); };
+               
+            result = processHierarchy(info, notNull);
+         }
+      }
+      catch (SchemaException exc)
+      {
+         exc.printStackTrace();
+      }
+      
+      return result;
+   }
+   
+   /**
     * Look up and return the AST which represents a database field in a schema, given the field's
     * name.
     * 
@@ -8347,11 +8474,13 @@
     * 
     * @param    clsName
     *           The qualified legacy name.
+    * @param    wa
+    *           The work area.
     *           
     * @throws   NullPointerException
     *           If a parent class can not be found. 
     */
-   private void parseHierarchy(String clsName)
+   private void parseHierarchy(String clsName, WorkArea wa)
    throws NullPointerException
    {
       ClassDefinition cdef = getClassDefinition(clsName);
@@ -8364,13 +8493,13 @@
       if (cdef.isProcessed())
       {
          return;
-      }
-      
+      }      
+
       if (cdef.getInterfaces() != null)
       {
          for (String iface : cdef.getInterfaces())
          {
-            parseHierarchy(iface);
+            parseHierarchy(iface, wa);
          }
       }
       
@@ -8380,10 +8509,10 @@
       {
          for (ClassDefinition parent : parents)
          {
-            parseHierarchy(parent.getName());
+            parseHierarchy(parent.getName(), wa);
          }
       }
-
+      
       cdef.setProcessed(true);
       
       String file = cdef.getFilename();
@@ -9487,7 +9616,7 @@
                return value;
             };
             
-            result = def.calcFromParentGraph(func, continu, backup);
+            result = def.calcFromParentGraph(func, continu, backup, true, false);
             
             if (exc[0] != null)
             {
@@ -9726,12 +9855,6 @@
        */
       private Map<String, ClassDefinition> classCache = new HashMap<>();
       
-      /** 
-       * A cache of converted class information (not by the current run). The key is the qualified 
-       * class name. 
-       */
-      private Map<String, ConvertedClassName> cvtCache = new HashMap<>();
-      
       /** Mapping of class files to their qualified name. */
       private Map<String, String> fname2qname = new HashMap<>();
       
@@ -9763,18 +9886,10 @@
       /** The set of class/interface references processed during 1st level parse of a class. */
       private Set<String> preScanRefs = new HashSet<>();
       
-      /**
-       * A mapping of (legacy-name, Java signature) to a map of legacy signatures, for which a 
-       * certain Java name must be enforced.  This is required to solve two cases:
-       * <ul>
-       *   <li>For override methods, the converted Java name must match.</li>
-       *   <li>For overloaded methods which convert to identical Java signaturesm, the converted
-       *       Java method name must be different.</li>
-       * </ul>
-       */
-      private Map<String, Map<String, String>> javaMethodCollisions = new HashMap<>();
+      /** An ordered set of class/interface references processed. */
+      private Set<String> processed = new LinkedHashSet<>();
       
-      /** The converted to generated Java names. */
+      /** The converter to generated Java names. */
       private NameConverter nconvert = new NameConverter();
   }
 }

=== modified file 'src/com/goldencode/p2j/uast/Variable.java'
--- old/src/com/goldencode/p2j/uast/Variable.java	2021-11-12 20:01:50 +0000
+++ new/src/com/goldencode/p2j/uast/Variable.java	2022-05-22 16:49:53 +0000
@@ -2,9 +2,9 @@
 ** Module   : Variable.java
 ** Abstract : contains the data needed to define a Progress variable
 **
-** Copyright (c) 2005-2021, Golden Code Development Corporation.
+** Copyright (c) 2005-2022, Golden Code Development Corporation.
 **
-** -#- -I- --Date-- --JPRM-- ----------------Description-----------------
+** -#- -I- --Date-- --JPRM-- ----------------------------------Description----------------------------------
 ** 001 GES 20050210   @19752 First version, simple bean-like approach.
 ** 002 GES 20050330   @20563 Added support for a large number of options
 **                           and helper methods to copy options and write
@@ -84,6 +84,8 @@
 **                           Added a custom mechanism for caller-defined annotations using the
 **                           AnnotationHelper interface.
 **     CA  20211112          XML-NODE-NAME must be annotated at the table field.
+**     GES 20220521          Added dataset signature annotation processing.  Cleaned up some warnings.
+**                           Removed unnecessary property handling. Added override flag.
 */
 
 /*
@@ -254,6 +256,12 @@
    
    /** Flag to differentiate instance and static members. */
    private boolean isStatic = false;
+
+   /** Flag for override option (properties and events only). */
+   private boolean isOverride = false;   
+   
+   /** Flag for abstract option (properties and events only). */
+   private boolean isAbstract = false;   
    
    /** Access mode if not defined in a method. */
    private int access = -1;
@@ -336,8 +344,6 @@
          Aast kwInit = copy.getImmediateChild(KW_INIT, null);
          if (kwInit != null && kwInit.getNumImmediateChildren() > 1)
          {
-            int size = kwInit.getNumImmediateChildren();
-            
             // Due to a bug in Progress 9.1c (and possibly other versions),
             // a temp-table field or var like some specific element of any
             // extent field/var always picks up the initial value of the
@@ -351,6 +357,8 @@
             Aast initTgt = kwInit.getChildAt(extent);
             if (initTgt == null)
             {
+               int size = kwInit.getNumImmediateChildren();
+               
                // We have more than one initializer value, but not enough
                // to match the index we were given, so use the last
                // available.
@@ -539,6 +547,26 @@
    }   
    
    /**
+    * Returns the override flag.
+    *
+    * @return   <code>true</code> if this is an overridden property or event.
+    */
+   public boolean isOverride()
+   {
+      return isOverride;
+   }   
+   
+   /**
+    * Returns the abstract flag.
+    *
+    * @return   <code>true</code> if this is an abstract property or event.
+    */
+   public boolean isAbstract()
+   {
+      return isAbstract;
+   }   
+   
+   /**
     * Returns the static flag.
     *
     * @return   <code>true</code> if this is a static member.
@@ -549,6 +577,28 @@
    }
    
    /**
+    * Sets the state of the override flag.
+    *
+    * @param    isOverride
+    *           <code>true</code> if this is an overridden property or event.
+    */
+   public void setOverride(boolean isOverride)
+   {
+      this.isOverride = isOverride;
+   }   
+   
+   /**
+    * Sets the state of the abstract flag.
+    *
+    * @param    isAbstract
+    *           <code>true</code> if this is an abstract property or event.
+    */
+   public void setAbstract(boolean isAbstract)
+   {
+      this.isAbstract = isAbstract;
+   }   
+   
+   /**
     * Sets the state of the property flag.
     *
     * @param    isProp
@@ -835,7 +885,7 @@
          boolean isEnum = ast.getType() == ENUM_VALUE;
          if (tempIdx != -1 && !builtin)
          {
-            ast.putAnnotation("tempidx", new Long(tempIdx));
+            ast.putAnnotation("tempidx", (long) tempIdx);
             if (clsDef != null)
             {
                ast.putAnnotation("tempidx-file", clsDef.getFilename());
@@ -874,7 +924,7 @@
          
          if (builtin)
          {
-            ast.putAnnotation("builtin", new Boolean(true));
+            ast.putAnnotation("builtin", true);
          }
          
          if (!original && clsDef != null)
@@ -885,7 +935,7 @@
          
          if (isProp)
          {
-            ast.putAnnotation("cls-property", new Boolean(true));
+            ast.putAnnotation("cls-property", true);
             ast.putAnnotation("cls-container", clsDef.getFilename());
          }
 
@@ -898,30 +948,61 @@
             // set default access mode (it will be overridden below if there is an
             // explicit mode specified
             access = isProp || isEnum || ast.getType() == DEFINE_EVENT ? KW_PUBLIC : KW_PRIVATE;
-            ast.putAnnotation("access-mode", new Long(access));
+            ast.putAnnotation("access-mode", (long) access);
+         }
+         
+         if (!original && ast.getType() == DATA_SET)
+         {
+            Aast ds = def.getImmediateChild(SYMBOL, null);
+            
+            if (ds == null)
+            {
+               throw new RuntimeException(String.format("Malformed dataset definition %s.", def.dumpTree()));
+            }
+            
+            String sig = (String) ds.getAnnotation("db_signature");
+            
+            if (sig == null)
+            {
+               throw new RuntimeException(String.format("Missing 'db_signature' annotation in dataset " +
+                                                        "definition %s.",
+                                                        def.dumpTree()));
+            }
+            
+            ast.putAnnotation("db_signature", sig);
          }
          
          if (!original && access != -1)
          {
             // access mode matters on the original definition, propagate it here
-            ast.putAnnotation("access-mode", new Long(access));
+            ast.putAnnotation("access-mode", (long) access);
          }
          
          if (isStatic || isEnum)
          {
-            ast.putAnnotation("static", new Boolean(true));
+            ast.putAnnotation("static", true);
+         }
+         
+         if (isOverride)
+         {
+            ast.putAnnotation("override", true);
+         }
+         
+         if (isAbstract)
+         {
+            ast.putAnnotation("abstract", true);
          }
          
          if (extent != 0)
          {
-            ast.putAnnotation("extent", new Long(extent));
+            ast.putAnnotation("extent", (long) extent);
          }
          
          if (isEnum)
          {
             def = ast;
             ast.putAnnotation("name", name);
-            ast.putAnnotation("type", new Long(tokenType));
+            ast.putAnnotation("type", (long) tokenType);
             return;
          }
          
@@ -942,7 +1023,7 @@
          
          if (tokenType != -1)
          {
-            ast.putAnnotation("type", new Long(tokenType));
+            ast.putAnnotation("type", (long) tokenType);
          }
          
          Aast child        = (Aast) def.getFirstChild();
@@ -978,23 +1059,23 @@
                case KW_INPUT:
                case KW_IN_OUT:
                case KW_OUTPUT:
-                  ast.putAnnotation("parmtype", new Long(ctype));
+                  ast.putAnnotation("parmtype", (long) ctype);
                   break;
                case KW_PUBLIC:
                case KW_PROTECTD:
                case KW_PRIVATE:
                   // remember the explicit type
                   access = ctype;
-                  ast.putAnnotation("access-mode", new Long(ctype));
+                  ast.putAnnotation("access-mode", (long) ctype);
                   break;
                case KW_STATIC:
-                  ast.putAnnotation("static", new Boolean(true));
+                  ast.putAnnotation("static", true);
                   break;
                case KW_ABSTRACT:
-                  ast.putAnnotation("abstract", new Boolean(true));
+                  ast.putAnnotation("abstract", true);
                   break;
                case KW_OVERRIDE:
-                  ast.putAnnotation("override", new Boolean(true));
+                  ast.putAnnotation("override", true);
                   break;
                case KW_FORMAT:
                   grandchild = (Aast) child.getFirstChild();
@@ -1048,7 +1129,7 @@
                                  // save our changes
                                  grandchild.setText(gtxt);
                                  
-                                 d = new Double(gtxt);
+                                 d = Double.parseDouble(gtxt);
                               }
                               else if (gtype == HEX_LITERAL)
                               {
@@ -1060,11 +1141,11 @@
                                  
                                  if (gtxt.length() == 0)
                                  {
-                                    d = new Double(0);
+                                    d = (double) 0;
                                  }
                                  else
                                  {
-                                    d = new Double(gtxt);
+                                    d = Double.parseDouble(gtxt);
                                  }
                               }
                               else if (gtype == BOOL_TRUE || gtype == BOOL_FALSE)
@@ -1072,7 +1153,7 @@
                                  // Progress silently accepts this initializer, we
                                  // assume it is the same as 0 (no init), but this
                                  // is untested at this time.
-                                 d = new Double(0);
+                                 d = (double) 0;
                               }
                            }
                            
@@ -1081,7 +1162,7 @@
                         case VAR_INT:
                         case VAR_INT64:
                            Long l = null;
-                        
+                           
                            if (!unknown)
                            {
                               if (gtype == DEC_LITERAL)                     
@@ -1089,12 +1170,12 @@
                                  // Progress allows decimal initializers for
                                  // integers, in this case we must round to the
                                  // nearest integer...
-                                 Double dd = new Double(gtxt);
-                                 l = new Long(Math.round(dd.doubleValue()));
+                                 Double dd = Double.parseDouble(gtxt);
+                                 l = (long) Math.round(dd.doubleValue());
                               }
                               else if (gtype == NUM_LITERAL)
                               {
-                                 l = new Long(gtxt);
+                                 l = Long.parseLong(gtxt);
                               }
                               else if (gtype == HEX_LITERAL)
                               {
@@ -1106,11 +1187,11 @@
                                  
                                  if (gtxt.length() == 0)
                                  {
-                                    l = new Long(0);
+                                    l = (long) 0;
                                  }
                                  else
                                  {
-                                    l = new Long(gtxt);
+                                    l = Long.parseLong(gtxt);
                                  }
                               }
                               else if (gtype == BOOL_TRUE ||
@@ -1119,7 +1200,7 @@
                                  // Progress silently accepts this initializer,
                                  // we assume it is the same as 0 (no init), but
                                  // this is untested at this time.
-                                 l = new Long(0);
+                                 l = (long) 0;
                               }
                            }
                            
@@ -1212,7 +1293,7 @@
                   int prec = ExpressionConversionWorker.literalToInt(child.getChildAt(0));
                   if (tokenType == VAR_DEC && prec != 10)
                   {
-                     ast.putAnnotation("decimals", new Long(prec));
+                     ast.putAnnotation("decimals", (long) prec);
                   }
                   break;
                case KW_EXTENT:
@@ -1264,48 +1345,7 @@
             if (ext != 0)
             {
                this.extent = ext;
-               ast.putAnnotation("extent", new Long(ext));
-            }
-         }
-            
-         if (isProp && clsDef != null && original && 
-             (!SymbolResolver.isPreScan() || (clsDef.isBuiltIn() && !clsDef.isDotNet())))
-         {
-            String[] mnames = 
-            {
-               "get",
-               "set",
-               "resize",
-               "length-of"
-            };
-            Aast ptype = def.getImmediateChild(KW_AS, null);
-            ptype = (Aast) ptype.getFirstChild();
-            String propType = ExpressionConversionWorker.expressionType(ptype, false);
-            ParameterKey[][] pks = 
-            {
-               null,
-               new ParameterKey[] { new ParameterKey(KW_INPUT, propType) },
-               new ParameterKey[] { new ParameterKey(KW_INPUT, "int64") },
-               null,
-            };
-            for (int i = 0; i < mnames.length; i++)
-            {
-               if (!isExtent() && i > 1)
-               {
-                  break;
-               }
-               String mname = mnames[i] + "-" + name;
-               String javaname = null;
-               String legacySignature = SymbolResolver.calculateLegacySignature(mname, pks[i]); 
-               if (clsDef.isBuiltIn())
-               {
-                  javaname = clsDef.getConvertedMethodName(legacySignature);
-               }
-               SymbolResolver.trackMethodSignature(javaname, mname, pks[i]);
-               
-               String javaSignature = SymbolResolver.calculateJavaSignature(mname, pks[i]);
-               def.putAnnotation(mnames[i] + "-legacysignature", legacySignature);
-               def.putAnnotation(mnames[i] + "-javasignature", javaSignature);
+               ast.putAnnotation("extent", (long) ext);
             }
          }
       }
@@ -1374,6 +1414,21 @@
                                  ", format string = " + fmt + ") ");
       }
    }
+
+   /**
+    * Render the instance as text.
+    * 
+    * @return   The details of this instance as text.
+    */
+   public String toString()
+   {
+      return String.format("VARIABLE name %s; token type %d; extent %d; classname %s; AST %s",
+                           name,
+                           tokenType,
+                           extent,
+                           cls,
+                           def == null ? "null" : def.dumpTree());
+   }
    
    /**
     * Helper to copy a child subtree of a specific type from the source to

